#!/system/bin/sh

# 恢复原始音频配置
restore_audio_config() {
  # 删除所有由模块设置的属性
  resetprop --delete persist.vendor.audio.bass.boost
  resetprop --delete persist.vendor.audio.treble.boost
  resetprop --delete persist.vendor.audio.surround.mode
  resetprop --delete persist.vendor.audio.eq.preset
  resetprop --delete persist.vendor.audio.drc.enable
  resetprop --delete persist.vendor.audio.loudness.enable
  resetprop --delete persist.vendor.audio.virtual.bass.enable
  resetprop --delete persist.vendor.audio.reverb.preset
  resetprop --delete persist.vendor.audio.voice.clarity
  resetprop --delete persist.vendor.audio.soundfield.expansion
  resetprop --delete persist.vendor.audio.headphone.optimize
  resetprop --delete persist.vendor.audio.speaker.optimize
  resetprop --delete persist.vendor.audio.resampler.quality
  resetprop --delete persist.vendor.audio.converter.quality
  resetprop --delete persist.vendor.audio.preset.mode
  
  # 设备特定属性
  resetprop --delete persist.vendor.audio.3d.effect
  resetprop --delete persist.vendor.audio.hifi.enhance
  resetprop --delete persist.vendor.audio.clarity.enhance
  resetprop --delete persist.vendor.audio.vocal.boost
  resetprop --delete persist.vendor.audio.dynamic.range
  resetprop --delete persist.vendor.audio.berlin_panoramic
resetprop --delete persist.vendor.audio.berlin_panoramic.strength
resetprop --delete persist.vendor.audio.spatial_audio
resetprop --delete persist.vendor.audio.spatial_audio.room_size
resetprop --delete persist.vendor.audio.soundstage_widener
resetprop --delete persist.vendor.audio.soundstage_widener.width
resetprop --delete persist.vendor.audio.precise_positioning
resetprop --delete persist.vendor.audio.precise_positioning.accuracy
resetprop --delete persist.vendor.audio.advanced_dsp
resetprop --delete persist.vendor.audio.dsp.resolution
resetprop --delete persist.vendor.audio.dsp.sampling_rate
  resetprop --delete persist.vendor.audio.miui_audio_engine
  resetprop --delete persist.vendor.audio.miui_audio_engine.level
  resetprop --delete persist.vendor.audio.mi_super_sound
  resetprop --delete persist.vendor.audio.mi_super_sound.intensity
  resetprop --delete persist.vendor.audio.mi_panorama_sound
  resetprop --delete persist.vendor.audio.mi_panorama_sound.width
  resetprop --delete persist.vendor.audio.mi_ai_audio
  resetprop --delete persist.vendor.audio.mi_ai_audio.level
  resetprop --delete persist.vendor.audio.mi_dsp_enhancement
  resetprop --delete persist.vendor.audio.mi_dsp_enhancement.quality
  resetprop --delete persist.vendor.audio.mi_drc
  resetprop --delete persist.vendor.audio.mi_drc.strength
  resetprop --delete persist.vendor.audio.mi_smart_eq
  resetprop --delete persist.vendor.audio.mi_smart_eq.precision
  resetprop --delete persist.vendor.audio.mi_spatial_audio
  resetprop --delete persist.vendor.audio.mi_spatial_audio.immersion
  resetprop --delete persist.vendor.audio.mi_bass_boost
  resetprop --delete persist.vendor.audio.mi_bass_boost.level
  resetprop --delete persist.vendor.audio.mi_treble_clarity
  resetprop --delete persist.vendor.audio.mi_treble_clarity.level
  resetprop --delete persist.vendor.audio.mi_voice_enhancement
  resetprop --delete persist.vendor.audio.mi_voice_enhancement.clarity
  resetprop --delete persist.vendor.audio.mi_surround
  resetprop --delete persist.vendor.audio.mi_surround.virtualization
  resetprop --delete persist.vendor.audio.mi_dynamic_processing
  resetprop --delete persist.vendor.audio.mi_dynamic_processing.adaptivity
  resetprop --delete persist.vendor.audio.mi_scene_optimization
  resetprop --delete persist.vendor.audio.mi_scene_optimization.intelligence
  resetprop --delete persist.vendor.audio.mi_hifi_mode
  resetprop --delete persist.vendor.audio.mi_hifi_mode.quality
  # 恢复原始audio_effects.conf
  if [ -f /data/adb/modules/xiaomi_pad6_audio_enhancer/system/vendor/etc/audio_effects.conf.bak ]; then
    cp /data/adb/modules/xiaomi_pad6_audio_enhancer/system/vendor/etc/audio_effects.conf.bak /vendor/etc/audio_effects.conf
  fi
}

# 主函数
on_uninstall() {
  restore_audio_config
  
  # 重启音频服务以应用更改
  killall audioserver
}

# 执行卸载
on_uninstall